diff --git a/avr-libc/configure.ac b/avr-libc/configure.ac
index 738190f..52aec11 100644
--- a/avr-libc/configure.ac
+++ b/avr-libc/configure.ac
@@ -1217,360 +1217,320 @@ AC_CONFIG_FILES([
 #avr1 and avr2
 AC_CONFIG_FILES([
 	avr/lib/avr2/Makefile
-	avr/lib/avr2/at90s1200/Makefile
-	avr/lib/avr2/at90s2313/Makefile
-	avr/lib/avr2/at90s2323/Makefile
-	avr/lib/avr2/at90s2333/Makefile
-	avr/lib/avr2/at90s2343/Makefile
-	avr/lib/avr2/at90s4414/Makefile
-	avr/lib/avr2/at90s4433/Makefile
-	avr/lib/avr2/at90s4434/Makefile
-	avr/lib/avr2/at90s8515/Makefile
-	avr/lib/avr2/at90c8534/Makefile
-	avr/lib/avr2/at90s8535/Makefile
-	avr/lib/avr2/attiny11/Makefile
-	avr/lib/avr2/attiny12/Makefile
-	avr/lib/avr2/attiny13/Makefile
-	avr/lib/avr2/attiny15/Makefile
-	avr/lib/avr2/attiny22/Makefile
-	avr/lib/avr2/attiny24/Makefile
-	avr/lib/avr2/attiny25/Makefile
-	avr/lib/avr2/attiny26/Makefile
-	avr/lib/avr2/attiny261/Makefile
-	avr/lib/avr2/attiny28/Makefile
-	avr/lib/avr2/attiny44/Makefile
-	avr/lib/avr2/attiny45/Makefile
-	avr/lib/avr2/attiny461/Makefile
-	avr/lib/avr2/attiny84/Makefile
-	avr/lib/avr2/attiny85/Makefile
-	avr/lib/avr2/attiny861/Makefile
-	avr/lib/avr2/attiny2313/Makefile
-	avr/lib/avr2/at86rf401/Makefile
+	avr/lib/dev/at90s1200/Makefile
+	avr/lib/dev/at90s2313/Makefile
+	avr/lib/dev/at90s2323/Makefile
+	avr/lib/dev/at90s2333/Makefile
+	avr/lib/dev/at90s2343/Makefile
+	avr/lib/dev/at90s4414/Makefile
+	avr/lib/dev/at90s4433/Makefile
+	avr/lib/dev/at90s4434/Makefile
+	avr/lib/dev/at90s8515/Makefile
+	avr/lib/dev/at90c8534/Makefile
+	avr/lib/dev/at90s8535/Makefile
+	avr/lib/dev/attiny11/Makefile
+	avr/lib/dev/attiny12/Makefile
+	avr/lib/dev/attiny15/Makefile
+	avr/lib/dev/attiny22/Makefile
+	avr/lib/dev/attiny26/Makefile
+	avr/lib/dev/attiny28/Makefile
 ])
 
 #avr2/tiny-stack
 AC_CONFIG_FILES([
 	avr/lib/avr2/tiny-stack/Makefile
-	avr/lib/avr2/tiny-stack/at90s2313/Makefile
-	avr/lib/avr2/tiny-stack/at90s2323/Makefile
-	avr/lib/avr2/tiny-stack/at90s2333/Makefile
-	avr/lib/avr2/tiny-stack/at90s2343/Makefile
-	avr/lib/avr2/tiny-stack/at90s4433/Makefile
-	avr/lib/avr2/tiny-stack/attiny22/Makefile
-	avr/lib/avr2/tiny-stack/attiny26/Makefile
 ])
 
 #avr25
 AC_CONFIG_FILES([
 	avr/lib/avr25/Makefile
-	avr/lib/avr25/at86rf401/Makefile
-	avr/lib/avr25/ata5272/Makefile
-	avr/lib/avr25/attiny13/Makefile
-	avr/lib/avr25/attiny13a/Makefile
-	avr/lib/avr25/attiny2313/Makefile
-	avr/lib/avr25/attiny2313a/Makefile
-	avr/lib/avr25/attiny24/Makefile
-	avr/lib/avr25/attiny24a/Makefile
-	avr/lib/avr25/attiny25/Makefile
-	avr/lib/avr25/attiny261/Makefile
-	avr/lib/avr25/attiny261a/Makefile
-	avr/lib/avr25/attiny4313/Makefile
-	avr/lib/avr25/attiny43u/Makefile
-	avr/lib/avr25/attiny44/Makefile
-	avr/lib/avr25/attiny44a/Makefile
-	avr/lib/avr25/attiny45/Makefile
-	avr/lib/avr25/attiny461/Makefile
-	avr/lib/avr25/attiny461a/Makefile
-	avr/lib/avr25/attiny48/Makefile
-	avr/lib/avr25/attiny828/Makefile
-	avr/lib/avr25/attiny84/Makefile
-	avr/lib/avr25/attiny84a/Makefile
-	avr/lib/avr25/attiny85/Makefile
-	avr/lib/avr25/attiny861/Makefile
-	avr/lib/avr25/attiny861a/Makefile
-	avr/lib/avr25/attiny87/Makefile
-	avr/lib/avr25/attiny88/Makefile
+	avr/lib/dev/at86rf401/Makefile
+	avr/lib/dev/ata5272/Makefile
+	avr/lib/dev/attiny13/Makefile
+	avr/lib/dev/attiny13a/Makefile
+	avr/lib/dev/attiny2313/Makefile
+	avr/lib/dev/attiny2313a/Makefile
+	avr/lib/dev/attiny24/Makefile
+	avr/lib/dev/attiny24a/Makefile
+	avr/lib/dev/attiny25/Makefile
+	avr/lib/dev/attiny261/Makefile
+	avr/lib/dev/attiny261a/Makefile
+	avr/lib/dev/attiny4313/Makefile
+	avr/lib/dev/attiny43u/Makefile
+	avr/lib/dev/attiny44/Makefile
+	avr/lib/dev/attiny44a/Makefile
+	avr/lib/dev/attiny45/Makefile
+	avr/lib/dev/attiny461/Makefile
+	avr/lib/dev/attiny461a/Makefile
+	avr/lib/dev/attiny48/Makefile
+	avr/lib/dev/attiny828/Makefile
+	avr/lib/dev/attiny84/Makefile
+	avr/lib/dev/attiny84a/Makefile
+	avr/lib/dev/attiny85/Makefile
+	avr/lib/dev/attiny861/Makefile
+	avr/lib/dev/attiny861a/Makefile
+	avr/lib/dev/attiny87/Makefile
+	avr/lib/dev/attiny88/Makefile
 ])
 
 #avr25/tiny-stack
 AC_CONFIG_FILES([
 	avr/lib/avr25/tiny-stack/Makefile
-	avr/lib/avr25/tiny-stack/attiny13/Makefile
-	avr/lib/avr25/tiny-stack/attiny13a/Makefile
-	avr/lib/avr25/tiny-stack/attiny2313/Makefile
-	avr/lib/avr25/tiny-stack/attiny2313a/Makefile
-	avr/lib/avr25/tiny-stack/attiny24/Makefile
-	avr/lib/avr25/tiny-stack/attiny24a/Makefile
-	avr/lib/avr25/tiny-stack/attiny25/Makefile
-	avr/lib/avr25/tiny-stack/attiny261/Makefile
-	avr/lib/avr25/tiny-stack/attiny261a/Makefile
 ])
 
 #avr3
 AC_CONFIG_FILES([
 	avr/lib/avr3/Makefile
-	avr/lib/avr3/atmega103/Makefile
-	avr/lib/avr3/at43usb320/Makefile
-	avr/lib/avr3/at43usb355/Makefile
-	avr/lib/avr3/at76c711/Makefile
-	avr/lib/avr3/at90usb82/Makefile
-	avr/lib/avr3/at90usb162/Makefile
+	avr/lib/dev/at43usb355/Makefile
+	avr/lib/dev/at76c711/Makefile
 ])
 
 #avr31
 AC_CONFIG_FILES([
 	avr/lib/avr31/Makefile
-	avr/lib/avr31/atmega103/Makefile
-	avr/lib/avr31/at43usb320/Makefile
+	avr/lib/dev/atmega103/Makefile
+	avr/lib/dev/at43usb320/Makefile
 ])
 
 #avr35
 AC_CONFIG_FILES([
 	avr/lib/avr35/Makefile
-	avr/lib/avr35/at90usb82/Makefile
-	avr/lib/avr35/at90usb162/Makefile
-	avr/lib/avr35/ata5505/Makefile
-	avr/lib/avr35/atmega8u2/Makefile
-	avr/lib/avr35/atmega16u2/Makefile
-	avr/lib/avr35/atmega32u2/Makefile
-	avr/lib/avr35/attiny167/Makefile
-	avr/lib/avr35/attiny1634/Makefile
+	avr/lib/dev/at90usb82/Makefile
+	avr/lib/dev/at90usb162/Makefile
+	avr/lib/dev/ata5505/Makefile
+	avr/lib/dev/atmega8u2/Makefile
+	avr/lib/dev/atmega16u2/Makefile
+	avr/lib/dev/atmega32u2/Makefile
+	avr/lib/dev/attiny167/Makefile
+	avr/lib/dev/attiny1634/Makefile
 ])
 
 #avr4
 AC_CONFIG_FILES([
 	avr/lib/avr4/Makefile
-	avr/lib/avr4/ata6285/Makefile
-	avr/lib/avr4/ata6286/Makefile
-	avr/lib/avr4/ata6289/Makefile
-	avr/lib/avr4/atmega48/Makefile
-	avr/lib/avr4/atmega48a/Makefile
-	avr/lib/avr4/atmega48pa/Makefile
-	avr/lib/avr4/atmega48p/Makefile
-	avr/lib/avr4/atmega8/Makefile
-	avr/lib/avr4/atmega8a/Makefile
-	avr/lib/avr4/atmega88/Makefile
-	avr/lib/avr4/atmega88a/Makefile
-	avr/lib/avr4/atmega88p/Makefile
-	avr/lib/avr4/atmega88pa/Makefile
-	avr/lib/avr4/atmega8515/Makefile
-	avr/lib/avr4/atmega8535/Makefile
-	avr/lib/avr4/atmega8hva/Makefile
-	avr/lib/avr4/at90pwm1/Makefile
-	avr/lib/avr4/at90pwm2/Makefile
-	avr/lib/avr4/at90pwm2b/Makefile
-	avr/lib/avr4/at90pwm3/Makefile
-	avr/lib/avr4/at90pwm3b/Makefile
-	avr/lib/avr4/at90pwm81/Makefile
+	avr/lib/dev/ata6285/Makefile
+	avr/lib/dev/ata6286/Makefile
+	avr/lib/dev/ata6289/Makefile
+	avr/lib/dev/atmega48/Makefile
+	avr/lib/dev/atmega48a/Makefile
+	avr/lib/dev/atmega48pa/Makefile
+	avr/lib/dev/atmega48p/Makefile
+	avr/lib/dev/atmega8/Makefile
+	avr/lib/dev/atmega8a/Makefile
+	avr/lib/dev/atmega88/Makefile
+	avr/lib/dev/atmega88a/Makefile
+	avr/lib/dev/atmega88p/Makefile
+	avr/lib/dev/atmega88pa/Makefile
+	avr/lib/dev/atmega8515/Makefile
+	avr/lib/dev/atmega8535/Makefile
+	avr/lib/dev/atmega8hva/Makefile
+	avr/lib/dev/at90pwm1/Makefile
+	avr/lib/dev/at90pwm2/Makefile
+	avr/lib/dev/at90pwm2b/Makefile
+	avr/lib/dev/at90pwm3/Makefile
+	avr/lib/dev/at90pwm3b/Makefile
+	avr/lib/dev/at90pwm81/Makefile
 ])
 
 #avr5
 AC_CONFIG_FILES([
 	avr/lib/avr5/Makefile
-	avr/lib/avr5/at90can32/Makefile
-	avr/lib/avr5/at90can64/Makefile
-	avr/lib/avr5/at90can128/Makefile
-	avr/lib/avr5/at90pwm216/Makefile
-	avr/lib/avr5/at90pwm316/Makefile
-	avr/lib/avr5/at90pwm161/Makefile
-	avr/lib/avr5/at90scr100/Makefile
-	avr/lib/avr5/at90usb646/Makefile
-	avr/lib/avr5/at90usb647/Makefile
-	avr/lib/avr5/at90usb1286/Makefile
-	avr/lib/avr5/at90usb1287/Makefile
-	avr/lib/avr5/at94k/Makefile 
-	avr/lib/avr5/ata5790/Makefile 
-	avr/lib/avr5/ata5795/Makefile 
-	avr/lib/avr5/atmega16/Makefile
-	avr/lib/avr5/atmega16a/Makefile
-	avr/lib/avr5/atmega161/Makefile
-	avr/lib/avr5/atmega162/Makefile
-	avr/lib/avr5/atmega163/Makefile
-	avr/lib/avr5/atmega164a/Makefile
-	avr/lib/avr5/atmega164p/Makefile
-	avr/lib/avr5/atmega164pa/Makefile
-	avr/lib/avr5/atmega165/Makefile
-	avr/lib/avr5/atmega165a/Makefile
-	avr/lib/avr5/atmega165p/Makefile
-        avr/lib/avr5/atmega165pa/Makefile
-	avr/lib/avr5/atmega168/Makefile
-	avr/lib/avr5/atmega168a/Makefile
-	avr/lib/avr5/atmega168p/Makefile
-	avr/lib/avr5/atmega168pa/Makefile
-	avr/lib/avr5/atmega169/Makefile
-	avr/lib/avr5/atmega169a/Makefile
-	avr/lib/avr5/atmega169p/Makefile
-	avr/lib/avr5/atmega169pa/Makefile
-	avr/lib/avr5/atmega16hva/Makefile
-	avr/lib/avr5/atmega16hva2/Makefile
-	avr/lib/avr5/atmega16hvb/Makefile
-	avr/lib/avr5/atmega16hvbrevb/Makefile
-	avr/lib/avr5/atmega16m1/Makefile
-	avr/lib/avr5/atmega16u4/Makefile
-	avr/lib/avr5/atmega32/Makefile
-	avr/lib/avr5/atmega32a/Makefile
-	avr/lib/avr5/atmega323/Makefile
-	avr/lib/avr5/atmega324a/Makefile
-	avr/lib/avr5/atmega324p/Makefile
-	avr/lib/avr5/atmega324pa/Makefile
-	avr/lib/avr5/atmega325/Makefile
-	avr/lib/avr5/atmega325a/Makefile
-	avr/lib/avr5/atmega325p/Makefile
-	avr/lib/avr5/atmega325pa/Makefile
-	avr/lib/avr5/atmega3250/Makefile
-	avr/lib/avr5/atmega3250a/Makefile
-	avr/lib/avr5/atmega3250p/Makefile
-	avr/lib/avr5/atmega3250pa/Makefile
-	avr/lib/avr5/atmega328/Makefile
-	avr/lib/avr5/atmega328p/Makefile
-	avr/lib/avr5/atmega329/Makefile
-	avr/lib/avr5/atmega329a/Makefile
-	avr/lib/avr5/atmega329p/Makefile
-	avr/lib/avr5/atmega329pa/Makefile
-	avr/lib/avr5/atmega3290/Makefile
-	avr/lib/avr5/atmega3290a/Makefile
-	avr/lib/avr5/atmega3290p/Makefile
-	avr/lib/avr5/atmega3290pa/Makefile
-	avr/lib/avr5/atmega32c1/Makefile
-	avr/lib/avr5/atmega32hvb/Makefile
-	avr/lib/avr5/atmega32hvbrevb/Makefile
-	avr/lib/avr5/atmega32m1/Makefile
-	avr/lib/avr5/atmega32u4/Makefile
-	avr/lib/avr5/atmega32u6/Makefile
-	avr/lib/avr5/atmega406/Makefile
-	avr/lib/avr5/atmega64rfr2/Makefile
-	avr/lib/avr5/atmega644rfr2/Makefile
-	avr/lib/avr5/atmega64/Makefile
-	avr/lib/avr5/atmega64a/Makefile
-	avr/lib/avr5/atmega640/Makefile
-	avr/lib/avr5/atmega644/Makefile
-	avr/lib/avr5/atmega644a/Makefile
-	avr/lib/avr5/atmega644p/Makefile
-	avr/lib/avr5/atmega644pa/Makefile
-	avr/lib/avr5/atmega645/Makefile
-	avr/lib/avr5/atmega645a/Makefile
-	avr/lib/avr5/atmega645p/Makefile
-	avr/lib/avr5/atmega6450/Makefile
-	avr/lib/avr5/atmega6450a/Makefile
-	avr/lib/avr5/atmega6450p/Makefile
-	avr/lib/avr5/atmega649/Makefile
-	avr/lib/avr5/atmega649a/Makefile
-	avr/lib/avr5/atmega649p/Makefile
-	avr/lib/avr5/atmega6490/Makefile
-	avr/lib/avr5/atmega6490a/Makefile
-	avr/lib/avr5/atmega6490p/Makefile
-	avr/lib/avr5/atmega64c1/Makefile
-	avr/lib/avr5/atmega64hve/Makefile
-	avr/lib/avr5/atmega64m1/Makefile
-	avr/lib/avr5/atmega128/Makefile
-	avr/lib/avr5/atmega1280/Makefile
-	avr/lib/avr5/atmega1281/Makefile
-	avr/lib/avr5/atmega1284p/Makefile
-	avr/lib/avr5/atmega128rfa1/Makefile
-	avr/lib/avr5/m3000/Makefile
+	avr/lib/dev/at90can32/Makefile
+	avr/lib/dev/at90can64/Makefile
+	avr/lib/dev/at90pwm216/Makefile
+	avr/lib/dev/at90pwm316/Makefile
+	avr/lib/dev/at90pwm161/Makefile
+	avr/lib/dev/at90scr100/Makefile
+	avr/lib/dev/at90usb646/Makefile
+	avr/lib/dev/at90usb647/Makefile
+	avr/lib/dev/at94k/Makefile 
+	avr/lib/dev/ata5790/Makefile 
+	avr/lib/dev/ata5795/Makefile 
+	avr/lib/dev/atmega16/Makefile
+	avr/lib/dev/atmega16a/Makefile
+	avr/lib/dev/atmega161/Makefile
+	avr/lib/dev/atmega162/Makefile
+	avr/lib/dev/atmega163/Makefile
+	avr/lib/dev/atmega164a/Makefile
+	avr/lib/dev/atmega164p/Makefile
+	avr/lib/dev/atmega164pa/Makefile
+	avr/lib/dev/atmega165/Makefile
+	avr/lib/dev/atmega165a/Makefile
+	avr/lib/dev/atmega165p/Makefile
+	avr/lib/dev/atmega165pa/Makefile
+	avr/lib/dev/atmega168/Makefile
+	avr/lib/dev/atmega168a/Makefile
+	avr/lib/dev/atmega168p/Makefile
+	avr/lib/dev/atmega168pa/Makefile
+	avr/lib/dev/atmega169/Makefile
+	avr/lib/dev/atmega169a/Makefile
+	avr/lib/dev/atmega169p/Makefile
+	avr/lib/dev/atmega169pa/Makefile
+	avr/lib/dev/atmega16hva/Makefile
+	avr/lib/dev/atmega16hva2/Makefile
+	avr/lib/dev/atmega16hvb/Makefile
+	avr/lib/dev/atmega16hvbrevb/Makefile
+	avr/lib/dev/atmega16m1/Makefile
+	avr/lib/dev/atmega16u4/Makefile
+	avr/lib/dev/atmega32/Makefile
+	avr/lib/dev/atmega32a/Makefile
+	avr/lib/dev/atmega323/Makefile
+	avr/lib/dev/atmega324a/Makefile
+	avr/lib/dev/atmega324p/Makefile
+	avr/lib/dev/atmega324pa/Makefile
+	avr/lib/dev/atmega325/Makefile
+	avr/lib/dev/atmega325a/Makefile
+	avr/lib/dev/atmega325p/Makefile
+	avr/lib/dev/atmega325pa/Makefile
+	avr/lib/dev/atmega3250/Makefile
+	avr/lib/dev/atmega3250a/Makefile
+	avr/lib/dev/atmega3250p/Makefile
+	avr/lib/dev/atmega3250pa/Makefile
+	avr/lib/dev/atmega328/Makefile
+	avr/lib/dev/atmega328p/Makefile
+	avr/lib/dev/atmega329/Makefile
+	avr/lib/dev/atmega329a/Makefile
+	avr/lib/dev/atmega329p/Makefile
+	avr/lib/dev/atmega329pa/Makefile
+	avr/lib/dev/atmega3290/Makefile
+	avr/lib/dev/atmega3290a/Makefile
+	avr/lib/dev/atmega3290p/Makefile
+	avr/lib/dev/atmega3290pa/Makefile
+	avr/lib/dev/atmega32c1/Makefile
+	avr/lib/dev/atmega32hvb/Makefile
+	avr/lib/dev/atmega32hvbrevb/Makefile
+	avr/lib/dev/atmega32m1/Makefile
+	avr/lib/dev/atmega32u4/Makefile
+	avr/lib/dev/atmega32u6/Makefile
+	avr/lib/dev/atmega406/Makefile
+	avr/lib/dev/atmega64rfr2/Makefile
+	avr/lib/dev/atmega644rfr2/Makefile
+	avr/lib/dev/atmega64/Makefile
+	avr/lib/dev/atmega64a/Makefile
+	avr/lib/dev/atmega640/Makefile
+	avr/lib/dev/atmega644/Makefile
+	avr/lib/dev/atmega644a/Makefile
+	avr/lib/dev/atmega644p/Makefile
+	avr/lib/dev/atmega644pa/Makefile
+	avr/lib/dev/atmega645/Makefile
+	avr/lib/dev/atmega645a/Makefile
+	avr/lib/dev/atmega645p/Makefile
+	avr/lib/dev/atmega6450/Makefile
+	avr/lib/dev/atmega6450a/Makefile
+	avr/lib/dev/atmega6450p/Makefile
+	avr/lib/dev/atmega649/Makefile
+	avr/lib/dev/atmega649a/Makefile
+	avr/lib/dev/atmega649p/Makefile
+	avr/lib/dev/atmega6490/Makefile
+	avr/lib/dev/atmega6490a/Makefile
+	avr/lib/dev/atmega6490p/Makefile
+	avr/lib/dev/atmega64c1/Makefile
+	avr/lib/dev/atmega64hve/Makefile
+	avr/lib/dev/atmega64m1/Makefile
+	avr/lib/dev/m3000/Makefile
 ])
 
 #avr51
 AC_CONFIG_FILES([
 	avr/lib/avr51/Makefile
-	avr/lib/avr51/atmega128/Makefile
-	avr/lib/avr51/atmega128a/Makefile
-	avr/lib/avr51/atmega1280/Makefile
-	avr/lib/avr51/atmega1281/Makefile
-	avr/lib/avr51/atmega1284/Makefile
-	avr/lib/avr51/atmega1284p/Makefile
-	avr/lib/avr51/atmega128rfa1/Makefile
-	avr/lib/avr51/atmega128rfr2/Makefile
-	avr/lib/avr51/atmega1284rfr2/Makefile
-	avr/lib/avr51/at90can128/Makefile
-	avr/lib/avr51/at90usb1286/Makefile
-	avr/lib/avr51/at90usb1287/Makefile
+	avr/lib/dev/atmega128/Makefile
+	avr/lib/dev/atmega128a/Makefile
+	avr/lib/dev/atmega1280/Makefile
+	avr/lib/dev/atmega1281/Makefile
+	avr/lib/dev/atmega1284/Makefile
+	avr/lib/dev/atmega1284p/Makefile
+	avr/lib/dev/atmega128rfa1/Makefile
+	avr/lib/dev/atmega128rfr2/Makefile
+	avr/lib/dev/atmega1284rfr2/Makefile
+	avr/lib/dev/at90can128/Makefile
+	avr/lib/dev/at90usb1286/Makefile
+	avr/lib/dev/at90usb1287/Makefile
 ])
 
 #avr6
 AC_CONFIG_FILES([
 	avr/lib/avr6/Makefile
-	avr/lib/avr6/atmega2560/Makefile
-	avr/lib/avr6/atmega2561/Makefile
-	avr/lib/avr6/atmega256rfr2/Makefile
-	avr/lib/avr6/atmega2564rfr2/Makefile
+	avr/lib/dev/atmega2560/Makefile
+	avr/lib/dev/atmega2561/Makefile
+	avr/lib/dev/atmega256rfr2/Makefile
+	avr/lib/dev/atmega2564rfr2/Makefile
 ])
 
 # avrxmega2
 AC_CONFIG_FILES([
 	avr/lib/avrxmega2/Makefile
-	avr/lib/avrxmega2/atxmega16a4/Makefile
-	avr/lib/avrxmega2/atxmega16a4u/Makefile
-	avr/lib/avrxmega2/atxmega16c4/Makefile
-	avr/lib/avrxmega2/atxmega16d4/Makefile
-	avr/lib/avrxmega2/atxmega32a4/Makefile
-	avr/lib/avrxmega2/atxmega32a4u/Makefile
-	avr/lib/avrxmega2/atxmega32c4/Makefile
-	avr/lib/avrxmega2/atxmega32d4/Makefile
+	avr/lib/dev/atxmega16a4/Makefile
+	avr/lib/dev/atxmega16a4u/Makefile
+	avr/lib/dev/atxmega16c4/Makefile
+	avr/lib/dev/atxmega16d4/Makefile
+	avr/lib/dev/atxmega32a4/Makefile
+	avr/lib/dev/atxmega32a4u/Makefile
+	avr/lib/dev/atxmega32c4/Makefile
+	avr/lib/dev/atxmega32d4/Makefile
 ])
 
 # avrxmega4
 AC_CONFIG_FILES([
 	avr/lib/avrxmega4/Makefile
-	avr/lib/avrxmega4/atxmega64a3/Makefile
-	avr/lib/avrxmega4/atxmega64a3u/Makefile
-	avr/lib/avrxmega4/atxmega64a4u/Makefile
-	avr/lib/avrxmega4/atxmega64b1/Makefile
-	avr/lib/avrxmega4/atxmega64b3/Makefile
-	avr/lib/avrxmega4/atxmega64c3/Makefile
-	avr/lib/avrxmega4/atxmega64d3/Makefile
-	avr/lib/avrxmega4/atxmega64d4/Makefile
+	avr/lib/dev/atxmega64a3/Makefile
+	avr/lib/dev/atxmega64a3u/Makefile
+	avr/lib/dev/atxmega64a4u/Makefile
+	avr/lib/dev/atxmega64b1/Makefile
+	avr/lib/dev/atxmega64b3/Makefile
+	avr/lib/dev/atxmega64c3/Makefile
+	avr/lib/dev/atxmega64d3/Makefile
+	avr/lib/dev/atxmega64d4/Makefile
 ])
 
 # avrxmega5
 AC_CONFIG_FILES([
 	avr/lib/avrxmega5/Makefile
-	avr/lib/avrxmega5/atxmega64a1/Makefile
-	avr/lib/avrxmega5/atxmega64a1u/Makefile
+	avr/lib/dev/atxmega64a1/Makefile
+	avr/lib/dev/atxmega64a1u/Makefile
 ])
 
 # avrxmega6
 AC_CONFIG_FILES([
 	avr/lib/avrxmega6/Makefile
-	avr/lib/avrxmega6/atxmega128a3/Makefile
-	avr/lib/avrxmega6/atxmega128a3u/Makefile
-	avr/lib/avrxmega6/atxmega128b1/Makefile
-	avr/lib/avrxmega6/atxmega128b3/Makefile
-	avr/lib/avrxmega6/atxmega128c3/Makefile
-	avr/lib/avrxmega6/atxmega128d3/Makefile
-	avr/lib/avrxmega6/atxmega128d4/Makefile
-	avr/lib/avrxmega6/atxmega192a3/Makefile
-	avr/lib/avrxmega6/atxmega192a3u/Makefile
-	avr/lib/avrxmega6/atxmega192c3/Makefile
-	avr/lib/avrxmega6/atxmega192d3/Makefile
-	avr/lib/avrxmega6/atxmega256a3/Makefile
-	avr/lib/avrxmega6/atxmega256a3u/Makefile
-	avr/lib/avrxmega6/atxmega256a3b/Makefile
-	avr/lib/avrxmega6/atxmega256a3bu/Makefile
-	avr/lib/avrxmega6/atxmega256c3/Makefile
-	avr/lib/avrxmega6/atxmega256d3/Makefile
-	avr/lib/avrxmega6/atxmega384c3/Makefile
-	avr/lib/avrxmega6/atxmega384d3/Makefile
+	avr/lib/dev/atxmega128a3/Makefile
+	avr/lib/dev/atxmega128a3u/Makefile
+	avr/lib/dev/atxmega128b1/Makefile
+	avr/lib/dev/atxmega128b3/Makefile
+	avr/lib/dev/atxmega128c3/Makefile
+	avr/lib/dev/atxmega128d3/Makefile
+	avr/lib/dev/atxmega128d4/Makefile
+	avr/lib/dev/atxmega192a3/Makefile
+	avr/lib/dev/atxmega192a3u/Makefile
+	avr/lib/dev/atxmega192c3/Makefile
+	avr/lib/dev/atxmega192d3/Makefile
+	avr/lib/dev/atxmega256a3/Makefile
+	avr/lib/dev/atxmega256a3u/Makefile
+	avr/lib/dev/atxmega256a3b/Makefile
+	avr/lib/dev/atxmega256a3bu/Makefile
+	avr/lib/dev/atxmega256c3/Makefile
+	avr/lib/dev/atxmega256d3/Makefile
+	avr/lib/dev/atxmega384c3/Makefile
+	avr/lib/dev/atxmega384d3/Makefile
 ])
 
 # avrxmega7
 AC_CONFIG_FILES([
 	avr/lib/avrxmega7/Makefile
-	avr/lib/avrxmega7/atxmega128a1/Makefile
-	avr/lib/avrxmega7/atxmega128a1u/Makefile
-	avr/lib/avrxmega7/atxmega128a4u/Makefile
+	avr/lib/dev/atxmega128a1/Makefile
+	avr/lib/dev/atxmega128a1u/Makefile
+	avr/lib/dev/atxmega128a4u/Makefile
 ])
 
 
 # avrtiny
 AC_CONFIG_FILES([
 	avr/lib/avrtiny/Makefile
-	avr/lib/avrtiny/attiny4/Makefile
-	avr/lib/avrtiny/attiny5/Makefile
-	avr/lib/avrtiny/attiny9/Makefile
-	avr/lib/avrtiny/attiny10/Makefile
-	avr/lib/avrtiny/attiny20/Makefile
-	avr/lib/avrtiny/attiny40/Makefile
+	avr/lib/dev/attiny4/Makefile
+	avr/lib/dev/attiny5/Makefile
+	avr/lib/dev/attiny9/Makefile
+	avr/lib/dev/attiny10/Makefile
+	avr/lib/dev/attiny20/Makefile
+	avr/lib/dev/attiny40/Makefile
 ])
 
 
diff --git a/avr-libc/devtools/Device.am b/avr-libc/devtools/Device.am
index aecad72..b4a2dc6 100644
--- a/avr-libc/devtools/Device.am
+++ b/avr-libc/devtools/Device.am
@@ -35,7 +35,9 @@ AVR_TARGET_CFLAGS   = <<crt_cflags>>
 AVR_TARGET_ASFLAGS  = <<crt_asflags>>
 AVR_INSTALL_DIR     = <<install_dir>>
 
-VPATH = $(top_srcdir)/crt1
+VPATH = $(top_srcdir)/crt1:$(top_srcdir)/libc/misc
+
+include $(top_srcdir)/libc/misc/Rules.am
 
 if HAS_<<dev>>
 
@@ -56,6 +58,8 @@ avrlibdir = $(__install_dir)
 
 noinst_LIBRARIES = libcrt.a
 nodist_libcrt_a_SOURCES = gcrt1.S
+avr_LIBRARIES = libdev.a
+libdev_a_SOURCES = $(eeprom_asm_sources)
 
 avr_DATA = $(AVR_TARGET_CRT)
 
diff --git a/avr-libc/devtools/gen-avr-lib-tree.sh b/avr-libc/devtools/gen-avr-lib-tree.sh
index bea01e9..a587360 100755
--- a/avr-libc/devtools/gen-avr-lib-tree.sh
+++ b/avr-libc/devtools/gen-avr-lib-tree.sh
@@ -56,9 +56,7 @@ AVR12_DEV_INFO="\
 at90s1200:crts1200.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 attiny11:crttn11.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 attiny12:crttn12.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny13:crttn13.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 attiny15:crttn15.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny2313:crttn2313.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 attiny28:crttn28.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90s2313:crts2313.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90s2323:crts2323.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
@@ -71,17 +69,7 @@ at90s8515:crts8515.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90s8535:crts8535.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90c8534:crtc8534.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 attiny22:crttn22.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny26:crttn26.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at86rf401:crt86401.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny25:crttn25.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny45:crttn45.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny85:crttn85.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny24:crttn24.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny44:crttn44.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny84:crttn84.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny261:crttn261.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny461:crttn461.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-attiny861:crttn861.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
+attiny26:crttn26.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
 "
 
 AVR12TS_DEV_INFO="\
@@ -137,12 +125,8 @@ attiny261a:crttn261a.o:${DEV_DEFS}:${CFLAGS_TINY_STACK}:${DEV_ASFLAGS}\
 "
 
 AVR3_DEV_INFO="\
-atmega103:crtm103.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at43usb320:crt43320.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at43usb355:crt43355.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at76c711:crt76711.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at90usb82:crtusb82.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at90usb162:crtusb162.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
+at76c711:crt76711.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
 "
 
 AVR31_DEV_INFO="\
@@ -189,15 +173,12 @@ at90pwm81:crt90pwm81.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
 AVR5_DEV_INFO="\
 at90can32:crtcan32.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90can64:crtcan64.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at90can128:crtcan128.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90pwm216:crt90pwm216.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90pwm316:crt90pwm316.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90pwm161:crt90pwm161.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90scr100:crt90scr100.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90usb646:crtusb646.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at90usb647:crtusb647.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at90usb1286:crtusb1286.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-at90usb1287:crtusb1287.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 at94k:crtat94k.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 ata5790:crta5790.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 ata5795:crta5795.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
@@ -282,11 +263,6 @@ atmega6490p:crtm6490p.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 atmega64c1:crtm64c1.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 atmega64hve:crtm64hve.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 atmega64m1:crtm64m1.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atmega128:crtm128.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atmega1280:crtm1280.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atmega1281:crtm1281.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atmega1284p:crtm1284p.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
-atmega128rfa1:crtm128rfa1.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS};\
 m3000:crtm3000.o:${DEV_DEFS}:${CFLAGS_SPACE}:${DEV_ASFLAGS}\
 "
 
@@ -428,6 +404,8 @@ cd avr/lib || exit 1
 IFS=';'
 ARH_SUBDIRS=""
 
+DEV_SUBDIRS=""
+
 for ath_lib in $AVR_ARH_INFO
 do
 	arh=`echo $ath_lib | cut -d ':' -f 1`
@@ -456,46 +434,47 @@ do
 	# Install directory for sed substitution, the '/' character is masked.
 	inst_dir_masked=`echo $install_dir | sed 's/\\//\\\\\\//'`
 
-	# In build tree.
-	subdir=${arh}${sublib:+/}${sublib}
-	echo "  avr/lib/$subdir/"
-
-	# The first record of each arch must be sublib-free.
-	test -d $subdir || mkdir $subdir
-	cd $subdir || exit 1
-
-	DEV_SUBDIRS=""
-
 	eval DEV_INFO=\"\$\{$dev_info\}\"
 
 	for dev_crt in $DEV_INFO
 	do
 		dev=`echo $dev_crt | cut -d ':' -f 1`
-		crt=`echo $dev_crt | cut -d ':' -f 2`
+		crt=crt1.o
 		crt_defs=`echo $dev_crt | cut -d ':' -f 3`
 		crt_cflags=`echo $dev_crt | cut -d ':' -f 4`
 		crt_asflags=`echo $dev_crt | cut -d ':' -f 5`
 
-		echo "  avr/lib/$subdir/$dev"
+		dev_inst_dir_masked="dev\\/$dev"
+
+		echo "  avr/lib/dev/$dev"
 
-		test -d $dev || mkdir $dev
+		test -d dev || mkdir dev
+		test -d dev/$dev || mkdir dev/$dev
 
-		cat $top_dir/devtools/Device.am > $dev/Makefile.am
+		cat $top_dir/devtools/Device.am > dev/$dev/Makefile.am
 
 		sed -e "s/<<dev>>/$dev/g" \
 		    -e "s/<<crt>>/$crt/g" \
 		    -e "s/<<crt_defs>>/$crt_defs/g" \
 		    -e "s/<<crt_cflags>>/$crt_cflags/g" \
 		    -e "s/<<crt_asflags>>/$crt_asflags/g"  \
-		    -e "s/<<install_dir>>/$inst_dir_masked/g" $dev/Makefile.am \
-		    > $dev/tempfile && mv -f $dev/tempfile $dev/Makefile.am
+		    -e "s/<<install_dir>>/$dev_inst_dir_masked/g" dev/$dev/Makefile.am \
+		    > dev/$dev/tempfile && mv -f dev/$dev/tempfile dev/$dev/Makefile.am
 
-		DEV_SUBDIRS="$DEV_SUBDIRS $dev"
+		DEV_SUBDIRS="$DEV_SUBDIRS dev/$dev"
 	done
 
+	# In build tree.
+	subdir=${arh}${sublib:+/}${sublib}
+	echo "  avr/lib/$subdir/"
+
+	# The first record of each arch must be sublib-free.
+	test -d $subdir || mkdir $subdir
+	cd $subdir || exit 1
+
 	cat $top_dir/devtools/Architecture.am > Makefile.am
 
-	sed -e "s/<<dev_subdirs>>/$DEV_SUBDIRS/g" \
+	sed -e "s/<<dev_subdirs>>//g" \
 	    -e "s/<<arh>>/$arh/g" \
 	    -e "s/<<lib_defs>>/$lib_defs/g" \
 	    -e "s/<<lib_cflags>>/$lib_cflags/g" \
@@ -536,7 +515,7 @@ done
 
 cat $top_dir/devtools/Lib.am > Makefile.am
 
-sed -e "s/<<arh_subdirs>>/`echo $ARH_SUBDIRS | sed 's/\\//\\\\\\//g'`/g" \
+sed -e "s/<<arh_subdirs>>/`echo $ARH_SUBDIRS $DEV_SUBDIRS | sed 's/\\//\\\\\\//g'`/g" \
     Makefile.am > tempfile && mv -f tempfile Makefile.am
 
 cd ..
diff --git a/avr-libc/libc/misc/Rules.am b/avr-libc/libc/misc/Rules.am
index 331dde5..b2bb7a7 100644
--- a/avr-libc/libc/misc/Rules.am
+++ b/avr-libc/libc/misc/Rules.am
@@ -31,42 +31,4 @@
 
 include $(top_srcdir)/libc/misc/Files.am
 
-# Example:
-#   eeprom_asm_sources --> eerd_byte.S eerd_word.S
-#   basename           --> eerd_byte eerd_word
-#   addsuffix          --> eerd_byte_ eerd_word_
-#   foreach            --> eerd_byte_atmega48 eerd_byte_atmega8
-#                          eerd_word_atmega48 eerd_word_atmega8
-#   addsuffix          --> eerd_byte_atmega48.o eerd_byte_atmega8.o
-#                          eerd_word_atmega48.o eerd_word_atmega8.o
-#
-eeprom_asm_basenames = $(basename $(eeprom_asm_sources))
-eeprom_asm_basenames2 = $(addsuffix _,$(eeprom_asm_basenames))
-eeprom_asm_baselist = $(foreach dev,$(AVRLIB_DEVLIST),\
-    $(addsuffix $(dev),$(eeprom_asm_basenames2)))
-eeprom_asm_objlist = $(addsuffix .o,$(eeprom_asm_baselist))
-
-misc_a_libadd = \
-	$(eeprom_asm_objlist)
-
-# Example of '-mmcu' arg generation:
-#   $@          --> eerd_byte_atmega48.o
-#   basename    --> eerd_byte_atmega48
-#   subst       --> eerd byte atmega48
-#   lastword    --> atmega48
-#
-# Example of source file generation:
-#   $@          --> eerd_byte_atmega48.o
-#   basename    --> eerd_byte_atmega48
-#   subst       --> eerd.byte.atmega48
-#   basename    --> eerd.byte
-#   subst       --> eerd_byte
-#   addsuffix   --> eerd_byte.S
-#
-$(eeprom_asm_objlist):	$(eeprom_asm_sources)
-	$(filter-out -mmcu=%,$(COMPILE) $(AVRLIB_ASFLAGS)) -c -o $@	\
-	    -mmcu=$(lastword $(subst _, ,$(basename $@)))		\
-	    $(<D)/$(addsuffix .S,\
-	    	    $(subst .,_,$(basename $(subst _,.,$(basename $@)))))
-
 # vim: set ft=make:
